Unit AnaSin; { Analizador Sintctico }
(*8-10-92*)  (* intentar que pushpattern sea lo contrario de poppattern *)
(*8-10-92*)  (* Sentencia While cambiada *)
(*20-12-93*) (* Cambia la sintaxis de Statement (Admite RELAX) *)
(*20-12-93*) (* SetTime y GetTime *)
(*22-12-93*) (* Shared *)
Interface

 Uses General, AnaLex, InsGame;

 Const
    MaxLabel = 1000;
    MaxLevel =10;

 Procedure Analizador_Sintactico;

 Implementation

 Const
   NoName = 0;

 Type
   Symbols = Set of SymbolType;

   Class = ( Constantx,
             SegmentType,
             StandardType,
             SubrangeType,
             SetType,
             ArrayType,
             RecordType,
             Field,
             Variable,
             ValueParameter,
             VarParameter,
             Procedur,
             Taskx,
             StandardProc,
             UnDefined);

   StatusType = ( Privatex, Shared);

   RWStatusType = ( ReadOnly, ReadWrite);

   Classes = Set of Class;

   Ptr = ^ObjectRecord;

   ObjectRecord = Record
                    Name : Integer;
                    Previous : Ptr;

                    case Kind : Class of
                       Constantx        : ( ConstValue : LongInt;
                                            ConstType : Ptr );

                       SegmentType      : ( itemType : Ptr;);

                       SubrangeType     : ( CotaInf, CotaSup : Longint;
                                            TipoElemt : Ptr );

		       SetType          : ( LowBound, UppBound : Longint;
														  BaseType : Ptr );

                       ArrayType        : ( LowerBound, UpperBound : Longint;
                                            IndexType, ElementType : Ptr );

                       RecordType       : ( RecordLength : Longint;
                                            LastField : Ptr);

                       Field            : ( FieldDispl : Longint;
                                            FieldType : Ptr );

                       Variable ,
                       ValueParameter,
                       VarParameter     : ( VarLevel, VarDispl, ParLevel : Longint;
                                            Status : StatusType;
                                            RWStatus : RWStatusType;
                                            VarType : Ptr);
                       Procedur,
                       Taskx            : ( ProcLevel, ProcLabel : LongInt;
                                            LastParam : Ptr)
                  end;

   BlockRecord = Record
                   TempLength, VarLength, MaxTemp: LongInt;
                   ElementalTemp, ElementalVar, ElementalMax : LongInt;
                   LastObject : Ptr
                 end;

   BlockTable = Array[0..MaxLevel] of BlockRecord;

 Var
   LevelPar : Longint;           (* Nivel de Paralelismo *)
   
   LevelFor : Longint;           (* Nivel de anidamiento de un For *)

   LineNo : LongInt;

   Symbol : SymbolType;

   Simbolo : LongInt;

   Argument : LongInt;

   AddSymbols, BlockSymbols, ConstantSymbols,
     ExpressionSymbols, FactorSymbols,
     LongSymbols, MultiplySymbols,
     ParameterSymbols, RelationSymbols,
     SelectorSymbols, SignSymbols, 
     SimpleExprSymbols, StatementSymbols, ProcedureSymbols,
     TermSymbols : Symbols;

   Block : BlockTable;

   BlockLevel : Longint;

   Types, Variables, Procedures : Classes;

   TypeUniversal , TypeInteger, TypeBoolean : Ptr;

   LabelNo : Longint;

   ControlBlockMax, ElementalBlockMax,
   ControlVarBlockMax, ElementalVarBlockMax : LongInt;

 { OUTPUT }



 Procedure Emit1(Op:OperationPart);
 begin
   Emit( Temp2, ord(Op))
 end;

 Procedure Emit2(Op:OperationPart; Arg:LongInt);
 begin
   Emit( Temp2, ord(Op));
   Emit( Temp2, Arg)
 end;

 Procedure Emit3(Op:OperationPart; Arg1,Arg2:LongInt);
 begin
   Emit( Temp2, ord(Op));
   Emit( Temp2, Arg1);
   Emit( Temp2, Arg2)
   end;

 Procedure Emit4(Op:OperationPart; Arg1,Arg2,Arg3:LongInt);
 begin
   Emit( Temp2, ord(Op));
   Emit( Temp2, Arg1);
   Emit( Temp2, Arg2);
   Emit( Temp2, Arg3);
   end;

 Procedure Emit5(Op:OperationPart; Arg1,Arg2,Arg3,Arg4:LongInt);
 begin
   Emit( Temp2, ord(Op));
   Emit( Temp2, Arg1);
   Emit( Temp2, Arg2);
   Emit( Temp2, Arg3);
   Emit( Temp2, Arg4);
 end;

 Procedure Emit6(Op:OperationPart; Arg1,Arg2,Arg3,Arg4, Arg5:LongInt);
 begin
   Emit( Temp2, ord(Op));
   Emit( Temp2, Arg1);
   Emit( Temp2, Arg2);
   Emit( Temp2, Arg3);
   Emit( Temp2, Arg4);
   Emit( Temp2, Arg5)
 end;


   { INPUT }


 Procedure NextSymbol;
 begin
   read( Temp1, Simbolo);
   Symbol := SymbolType (Simbolo);
   while Symbol = NewLine1 do
     begin
       read(Temp1,LineNo);
       Emit2( NewLine2, LineNo);
       NewLine(LineNo);
       read( Temp1, Simbolo);
       Symbol := SymbolType (Simbolo);
     end;
   if Symbol in LongSymbols then
     read( Temp1, Argument)
 end;



   { SCOPE ANALISIS }

 Procedure Search( Name, LevelNo: Longint; Var Found: Boolean; Var Objt: Ptr);
 Var
   More: Boolean;
 begin
   More := True;
   Objt := Block[LevelNo].LastObject;
   while More do
      if Objt = nil then
         begin
           More := False;
           Found:= False
         end
      else if Objt^.Name = Name then
         begin
           More:= False;
           Found:= True
         end
      else
        Objt := Objt^.Previous
 end;

 Procedure Define( Name:Longint; Kind:Class; Var Objt:Ptr);
 Var
   Found: Boolean;
   Other: Ptr;
 begin
   if Name <> NoName then
     begin
       Search(Name, BlockLevel, Found, Other);
       if Found then Error(ambiguous3)
     end;
   New(Objt);
   Objt^.Name := Name;
   Objt^.Previous := Block[BlockLevel].LastObject;
   Objt^.Kind := Kind;
   Block[BlockLevel].LastObject := Objt
 end;

 Procedure Find(Name: Longint; Var Objt: Ptr);
 Var
   More, Found: Boolean;
   LevelNo: Longint;
 begin
   More := True;
   LevelNo := BlockLevel;
   while More do
     begin
       Search(Name, LevelNo, Found, Objt);
       if Found or (LevelNo = 0) then More := False
       else LevelNo := LevelNo - 1
     end;
   if Not Found then
      begin
        Error(UnDefined3);
        Define(Name, UnDefined, Objt)
      end
 end;

 Procedure NewBlock;
 Var
   Current : BlockRecord;
 begin
   TestLimit(BlockLevel, MaxLevel);
   BlockLevel := BlockLevel + 1;
   Current.TempLength := 0;
   Current.VarLength := 0;
   Current.MaxTemp := 0;
   Current.ElementalTemp := 0;
   Current.ElementalMax := 0;
   Current.ElementalVar := 0;
   Current.LastObject := nil;
   Block[BlockLevel] := Current
 end;

 Procedure EndBlock;
 begin
   { Para calcular la mxima Longitud de un bloque en la pila }
   ControlBlockMax := ControlBlockMax + Block[BlockLevel].MaxTemp;
   ElementalBlockMax := ElementalBlockMax + Block[BlockLevel].ElementalMax;
   ControlVarBlockMax := ControlVarBlockMax + Block[BlockLevel].VarLength;
   ElementalVarBlockMax := ElementalVarBlockMax + Block[BlockLevel].ElementalVar;
   BlockLevel := BlockLevel - 1
 end;

 Procedure StandardBlock;
 Var
   Constx,  VarProcessorx, Proc, VarCounterx : Ptr;
 begin
   BlockLevel := -1;
   NewBlock;

   Define( NoName, StandardType, TypeUniversal);

   Define( Integer0, StandardType, TypeInteger);

   Define( Boolean0, StandardType, TypeBoolean);

   Define(False0, Constantx, Constx);
   Constx^.ConstValue := ord(False);
   Constx^.ConstType := TypeBoolean;

   Define(True0, Constantx, Constx);
   Constx^.ConstValue := ord(True);
   Constx^.ConstType := TypeBoolean;

   Define(read0, StandardProc, Proc);
   Define(write0, StandardProc, Proc);

   Define( writeln0, StandardProc, Proc);
   Define( readln0, StandardProc, Proc);

   Define( randomize0, StandardProc, Proc);

   Define( gettime0, StandardProc, Proc);
   Define( settime0, StandardProc, Proc);

   Define( debug0, StandardProc, Proc);

   Define( broadcast0, StandardProc, Proc);

   (* Estoy Definiendo la Variable estandar "NAME" del Tipo rango de
      Procesadores. Hay que tenerlo en cuenta en el anlisis de Tipo  *)

   Define( Name0, Variable, VarProcessorx);
   VarProcessorx^.VarType := TypeInteger;
   VarProcessorx^.RWStatus := ReadOnly;
   VarProcessorx^.VarLevel := 0;
   VarProcessorx^.VarDispl := 0;

   Define( counter0, Variable, VarCounterx);
   VarCounterx^.VarType := TypeInteger;
   VarCounterx^.RWStatus := ReadOnly;
   VarCounterx^.VarLevel := 0;
   VarCounterx^.VarDispl := 0;

 end;


   { TYPE ANALYSIS }

 Procedure CheckTypes( Var Type1 : Ptr; Type2 : Ptr);
 begin
   if (type1^.kind = SegmentType ) and ( type2^.kind = SegmentType) then
     begin
       if type1^.itemType <> type2^.itemType then
       begin
         Error(Type3);
         Type1 := TypeUniversal;
       end;
     end
   else
   if Type1 <> Type2 then
      begin
        if ( Type1 <> TypeUniversal) and (Type2 <> TypeUniversal) then
            Error(Type3);
        Type1 := TypeUniversal
      end
 end;

 Procedure TypeError( Var Typex :Ptr);
 begin
   if Typex <> TypeUniversal then
      begin
        Error(Type3);
        Typex := TypeUniversal
      end
 end;

 Procedure KindError(Objt: Ptr);
 begin
   if Objt^.Kind <> UnDefined then Error(Kind3)
 end;


   { VARIABLE ADDRESSING }

 function TypeLength( Typex: Ptr): Longint;
 begin
   if ( Typex^.Kind = StandardType ) or ( Typex^.Kind = SubrangeType ) then
     TypeLength := 1
   else if Typex^.Kind = SegmentType then
     TypeLength := 2
   else if Typex^.Kind = SetType then
     TypeLength := ( ( Typex^.UppBound - Typex^.LowBound ) div wordPRAM ) + 1
   else if Typex^.Kind = ArrayType then
     TypeLength := (Typex^.UpperBound - Typex^.LowerBound + 1) * TypeLength(Typex^.ElementType)
   else { Typex^.Kind = RecordType }
     TypeLength := Typex^.RecordLength
 end; (* TypeLength *)

 Procedure FieldAddressing( RecordLength: Longint; LastField: Ptr);
 Var
   Displ: Longint;
 begin
   Displ := RecordLength;
   while Displ > 0 do
     begin
       Displ := Displ - TypeLength(LastField^.FieldType);
       LastField^.FieldDispl := Displ;
       LastField := LastField^.Previous
     end
 end; (* FieldAddressing *)

 Procedure VariableAddressing( VarLength: Longint; LastVar: Ptr);
 Var
   Displ: Longint;
 begin
   Displ := 3 + VarLength;
   while Displ > 3 do
     begin
       Displ := Displ - TypeLength( LastVar^.VarType);
       LastVar^.VarLevel := BlockLevel;
       LastVar^.VarDispl := Displ;
       LastVar^.ParLevel := LevelPar;              (* Status *)
       LastVar^.RWStatus := ReadWrite;
       LastVar := LastVar^.Previous
     end
 end; (* VariableAddressing *)

 Procedure ParameterAddressing( ParamLength: Longint; LastParam: Ptr);
 Var
   Displ:Longint;
 begin
   Displ := 0;
   while Displ > - ParamLength do
     begin
       if LastParam^.Kind = VarParameter then
           Displ := Displ - 1
       else { LastParam^.Kind = ValueParameter }
          Displ := Displ - TypeLength(LastParam^.VarType);
       LastParam^.VarLevel := BlockLevel;
       LastParam^.VarDispl := Displ;
       LastParam^.ParLevel := LevelPar;
       LastParam^.RWStatus := ReadWrite;
       LastParam := LastParam^.Previous
     end
 end;

   { LABELS }

 Procedure NewLabel(Var No: Longint);
 begin
   TestLimit(LabelNo,MaxLabel);
   LabelNo := LabelNo + 1;
   No := LabelNo
 end;

   { TEMPORARIES }

 Procedure Push( EdoPar, Length: LongInt);
 begin
    if EdoPar <> 0 then
      with Block[BlockLevel] do
        begin
          ElementalTemp := ElementalTemp + Length;
          if ElementalMax < ElementalTemp then
            ElementalMax := ElementalTemp
        end
    else
      with Block[BlockLevel] do
        begin
          TempLength := TempLength + Length;
          if MaxTemp < TempLength then
            MaxTemp := TempLength
        end
 end;

 Procedure Pop( EdoPar, Length: LongInt);
 begin
   with Block[BlockLevel] do
    if EdoPar <> 0 then
      ElementalTemp := ElementalTemp - Length
    else
      TempLength := TempLength - Length
 end;


   { INITIALIZATION }

 Procedure Initialize;
 begin
   AddSymbols := [ minus1, or1, plus1 ];
   BlockSymbols := [ begin1, Const1, Procedure1, shared1, Type1, Var1 ];
   ConstantSymbols := [ Name1, numeral1 ];
   ExpressionSymbols := [ leftParenthesis1, minus1, Name1, Not1, numeral1, plus1, andpersand1, random1, size1];
   FactorSymbols := [ leftParenthesis1, Name1, Not1, numeral1, random1, size1 ];
   LongSymbols := [ Name1, numeral1, char1 ];
   MultiplySymbols := [ and1, asterisk1, div1, mod1, shl1, shr1, xor1, max1, min1];
   ParameterSymbols := [ Name1, Var1 ];
   RelationSymbols := [ equal1, greater1, less1, Notequal1, Notgreater1, Notless1, in1 ];
   SelectorSymbols := [ leftbracket1, period1 ];
   SignSymbols := [ minus1, plus1, andpersand1 ];
   StatementSymbols := [ begin1, if1, Name1, while1, repeat1, relax1, Var1, for1, Parallel1 ];
   TermSymbols := FactorSymbols;
   SimpleExprSymbols := SignSymbols + TermSymbols;
   ProcedureSymbols := [ shared1, Procedure1 ];


   Types := [ StandardType, SubrangeType, SetType, SegmentType, ArrayType, RecordType ];
   Variables := [ Variable, ValueParameter, VarParameter ];
   Procedures := [ Procedur, Taskx, StandardProc];

   LabelNo := 0;
   LevelPar := 0;
   LevelFor := 0;

   ControlBlockMax := 0;
   ElementalBlockMax := 0;
   ControlVarBlockMax := 0;
   ElementalVarBlockMax := 0;

 end;

   { SYNTAX ANALYSIS }

 Procedure SyntaxError( Stop: Symbols);
 begin
   Error(Syntax3);
   while Not (Symbol in Stop) do
     NextSymbol
 end;

 Procedure SyntaxCheck( Stop: Symbols);
 begin
   if Not (Symbol in Stop) then
      SyntaxError(Stop)
 end;

 Procedure Expect( s: SymbolType; Stop: Symbols);
 begin
   if Symbol = s then NextSymbol
   else SyntaxError(Stop);
   SyntaxCheck(Stop)
 end;

 Procedure ExpectName( Var Name: Longint; Stop: Symbols);
 begin
    if Symbol = Name1 then
       begin
         Name := Argument;
         NextSymbol
       end
    else
       begin
         Name := NoName;
         SyntaxError(Stop)
       end;
    SyntaxCheck(Stop)
 end;

 { TypeName = Name. }
 Procedure TypeName( Var Typex : Ptr; Stop : Symbols);
 Var
   Objt: Ptr;
 begin
   if Symbol = Name1 then
      begin
        Find( Argument, Objt);
        if Objt^.Kind in Types then  Typex := Objt
        else
           begin
             KindError(Objt);
             Typex := TypeUniversal
           end
      end
   else Typex := TypeUniversal;
   Expect(Name1,Stop)
 end;

 { ImplicitTypeDefinition = TypeName | "SEGMENT OF" TypeName }
 procedure ImplicitTypeDefinition( var Typex : Ptr; Stop : Symbols);
 var Objt, itemType : Ptr;
 begin
   if symbol = Name1 then
     TypeName( Typex, Stop)
   else
     begin
       Expect( Segment1, [of1, Name1] + Stop);
       Expect( Of1, [Name1] + Stop);
       TypeName( itemType, Stop);

       (* CheckTypes( itemType, TypeInteger);*)
       (*
        * puede ser un segmento de cualquier tipo de vector
        *)

       New(Objt);
       Objt^.Name := noname;
       Objt^.Previous := NIL;
       Objt^.Kind := SegmentType;
       Objt^.itemType := itemType;

       Typex := Objt;
     end;
 end;



 { Constant = Numeral | ConstantName. }
 Procedure Constant( Var Value:LongInt; Var Typex: Ptr; Stop:Symbols);
 Var	Objt : Ptr;
 begin
   if Symbol = Numeral1 then
      begin
        Value := Argument;
        Typex := TypeInteger;
        Expect(Numeral1,Stop)
      end
   else if Symbol = Name1 then
      begin
        Find(Argument, Objt);
        if Objt^.Kind = Constantx then
           begin
             Value := Objt^.ConstValue;
             Typex := Objt^.ConstType
           end
        else
           begin
             KindError(Objt);
             Value := 0;
             Typex := TypeUniversal
           end;
        Expect(Name1,Stop)
      end
   else
      begin
        SyntaxError(Stop);
        Value := 0;
        Typex := TypeUniversal
      end
 end;

 { ConstantDefinition = ConstantName "=" Constant ";" . }
 Procedure ConstantDefinition( Stop:Symbols);
 Var
   Value : LongInt;
	Name  : Longint;
   Constx, Typex: Ptr;
 begin
   ExpectName( Name, [ equal1, semicolon1 ] + ConstantSymbols + Stop);
   Expect( equal1, ConstantSymbols + [semicolon1 ] + Stop);
   Constant( Value, Typex, [semicolon1] + Stop );
   Define( Name, Constantx, Constx);
   Constx^.ConstValue := Value;
   Constx^.ConstType := Typex;
   Expect( semicolon1, Stop)
 end;

 { ConstantDefinitionPart = "Const" ConstantDefinition
                             [ ConstantDefinition ] . }
 Procedure ConstantDefinitionPart( Stop:Symbols);
 Var
   Stop2: Symbols;
 begin
   Stop2 := [Name1] + Stop;
   Expect( Const1, Stop2 );
   ConstantDefinition( Stop2 );
   while Symbol = Name1 do
     ConstantDefinition( Stop2 )
 end;

 { NewSubrangeType = Constant ".." Constant }
 Procedure NewSubrangeType ( Name : Longint; Stop : Symbols);
 Var
   NewType, LowerType, UpperType, ElemenType : Ptr;
   LowerBound, UpperBound : LongInt;
 begin
   Constant(LowerBound, LowerType, [doublEdot1] + ConstantSymbols + Stop);
   Expect( DoubleDot1, ConstantSymbols + Stop);
   Constant( UpperBound, UpperType, Stop);
   CheckTypes( LowerType, UpperType);
   if LowerBound > UpperBound then
      begin
        Error(Range3);
        LowerBound := UpperBound
      end;
   Define( Name, SubrangeType, NewType);
   NewType^.CotaInf := LowerBound;
   NewType^.CotaSup := UpperBound;
   NewType^.TipoElemt := LowerType
 end;

 { NewSetType = "Set" "of" IndexRange. }
 Procedure NewSetType( Name: Longint; Stop: Symbols);
 Var
   Obj, NewType, LowerType, UpperType : Ptr;
   LowBound, UppBound : Longint;
 begin
   Expect( Set1, [of1, Name1] + Stop);
   Expect( of1, [Name1] + Stop);
   if Symbol = Name1 then
     begin
       Find( Argument, Obj );
       if Obj^.Kind = Constantx then
         begin
           Expect( Name1, [doublEdot1, rightbracket1,of1, Name1]+ ConstantSymbols + Stop);
           LowBound := Obj^.ConstValue;
           LowerType := Obj^.ConstType;
           Expect( doublEdot1, [rightbracket1, of1, Name1] + ConstantSymbols + Stop);
           Constant( UppBound, UpperType, [rightbracket1, of1, Name1] + Stop);
           CheckTypes( LowerType, UpperType );
         end
       else if Obj^.Kind = SubrangeType then
         begin
	   Expect( Name1, [rightbracket1, of1, Name1] + Stop);
	   LowBound := Obj^.CotaInf;
	   UppBound := Obj^.CotaSup;
	   LowerType := Obj^.TipoElemt;
       	 end
       else
         begin
	   KindError(Obj);
	   Obj:= TypeUniversal;
       	 end
     end (* name1 *)
   else
     begin
       Constant( LowBound, LowerType, [doublEdot1, rightbracket1, of1, Name1]+ ConstantSymbols + Stop);
       Expect( doubledot1,[rightbracket1, of1, Name1] + ConstantSymbols + Stop);
       Constant( UppBound, UpperType,[ rightbracket1, of1, Name1 ] + Stop);
       CheckTypes( LowerType, UpperType);
     end;
   if LowBound > UppBound then
     begin
       Error( range3 );
       LowBound := UppBound
     end;
   Define( Name, SetType, NewType);
   NewType^.LowBound := LowBound;
   NewType^.UppBound := UppBound;
   NewType^.BaseType := LowerType
 end;

 { NewArrayType =
           "Array" "[" IndexRange "]" "of" TypeName .
   IndexRange = TypeSubrangeName | Constant ".." Constant . }
 Procedure NewArrayType(Name:Longint; Stop: Symbols);
 Var
   Objt, NewType, LowerType, UpperType, ElementType : Ptr;
   LowerBound, UpperBound: LongInt;
 begin
   Expect(Array1, [leftbracket1, rightbracket1, of1,Name1] +
                  ConstantSymbols + Stop);
   Expect(leftbracket1, [rightbracket1, of1, Name1] +
                         ConstantSymbols + Stop);
   if Symbol = Name1 then
     begin
     Find(Argument,Objt);
     if Objt^.Kind = Constantx then
        begin
          Expect(Name1,[doublEdot1, rightbracket1,of1, Name1]+
                                   ConstantSymbols + Stop);
          LowerBound := Objt^.ConstValue;
          LowerType := Objt^.ConstType;
          Expect(doublEdot1,[rightbracket1, of1, Name1] +
                         ConstantSymbols + Stop);
          Constant(UpperBound, UpperType,[rightbracket1, of1, Name1] + Stop);
          CheckTypes(LowerType, UpperType);
        end
     else if Objt^.Kind = SubrangeType then
        begin
          Expect(Name1, [rightbracket1, of1, Name1] + Stop);
          LowerBound := Objt^.CotaInf;
          UpperBound := Objt^.CotaSup;
          LowerType := Objt^.TipoElemt;
        end
     else
        begin
          KindError(Objt);
          Objt:= TypeUniversal;
        end
     end
   else
     begin
      Constant(LowerBound, LowerType, [doublEdot1, rightbracket1,
                of1, Name1]+ ConstantSymbols + Stop);
      Expect(doublEdot1,[rightbracket1, of1, Name1] +
                         ConstantSymbols + Stop);
      Constant(UpperBound, UpperType,[rightbracket1, of1, Name1] + Stop);
      CheckTypes(LowerType, UpperType);
     end;
   if LowerBound > UpperBound then
       begin
          Error(range3);
          LowerBound := UpperBound
       end;
   Expect(rightbracket1, [of1, Name1] + Stop);
   Expect(of1, [Name1] + Stop);
   TypeName(ElementType,Stop);
   Define( Name, ArrayType, NewType);
   NewType^.LowerBound := LowerBound;
   NewType^.UpperBound := UpperBound;
   NewType^.IndexType := LowerType;
   NewType^.ElementType := ElementType
 end;

 { RecordSection = FieldName SectionTail .
   SectionTail =
           "," RecordSection | ":" TypeName . }
 Procedure Recordsection(Var number: Longint;
                    Var LastField, Typex: Ptr; Stop: Symbols);
 Var
   Name: Longint;
   Fieldx: Ptr;
 begin
   ExpectName( Name, [comma1, colon1] + Stop);
   Define( Name, Field, Fieldx);
   if Symbol = comma1 then
      begin
        Expect( comma1, [Name1] + Stop);
        Recordsection( number, LastField, Typex, Stop);
        number := number + 1
      end
   else
      begin
        Expect( colon1, [Name1] + Stop);
        TypeName( Typex, Stop);
        LastField := Fieldx;
        number := 1
      end;
   Fieldx^.FieldType := Typex
 end;

 { FieldList = RecordSection [ ";" RecordSection ] .}
 Procedure Fieldlist( Var LastField : Ptr;
                      Var Length : Longint; Stop : Symbols);
 Var
   Stop2 : Symbols;
   number : Longint;
   Typex : Ptr;
 begin
   Stop2 := [semicolon1] + Stop;
   Recordsection(number, LastField, Typex, Stop2);
   Length := number * TypeLength(Typex);
   while Symbol = semicolon1 do
      begin
         Expect( semicolon1, [Name1] + Stop2);
         Recordsection( number, LastField, Typex, Stop2);
         Length := Length + number * TypeLength(Typex)
     end;
   FieldAddressing( Length, LastField)
 end;

 { NewRecordType = "Record" FieldList "end" .}
 Procedure NewRecordType( Name : Longint; Stop : Symbols);
 Var
   NewType, LastField : Ptr;
   Length : Longint;
 begin
   NewBlock;
   Expect( Record1, [Name1, end1] + Stop);
   Fieldlist( LastField, Length, [end1] + Stop);
   Expect( end1, Stop);
   endBlock;
   Define( Name, RecordType, NewType);
   NewType^.RecordLength := Length;
   NewType^.LastField := LastField
 end;

 { TypeDefinition = TypeName "=" NewType ";".
   NewType = NewSubrangeType | NewSetType |
             NewArrayType | NewRecordType . }
 Procedure TypeDefinition( Stop : Symbols );
 Var
   Stop2: Symbols;
   Name: Longint;
   Objt: Ptr;
 begin
   Stop2:= [semicolon1] + Stop;
   ExpectName( Name, [equal1, leftParenthesis1, Name1, numeral1, Set1,
                             Array1, Record1] + Stop2);
   Expect( equal1, [leftParenthesis1, Name1, numeral1, Set1,
                                 Array1, Record1] + Stop2);
   if (Symbol = Name1) or (Symbol = numeral1) then
                                  NewSubrangeType( Name,Stop2)
   else if Symbol = Set1 then NewSetType(Name,Stop2)
   else if Symbol = Array1 then NewArrayType(Name, Stop2)
   else if Symbol = Record1 then NewRecordType(Name, Stop2)
   else
     begin
       Define(Name, UnDefined, Objt);
       SyntaxError(Stop2);
     end;
   Expect(semicolon1, Stop)
 end;

 { TypeDefinitionPart = "Type" TypedDefIniton [ TypeDefinition ] .}
 Procedure TypeDefinitionPart(Stop: Symbols);
 Var
   Stop2: Symbols;
 begin
   Stop2 := [Name1] + Stop;
   Expect( Type1, Stop2 );
   TypeDefinition( Stop2 );
   while Symbol = Name1 do
      TypeDefinition( Stop2 )
 end;

 { VariableGroup = VariableName GroupTail .
   GroupTail  = "," VariableGroup | ":" [ SHARED ] TypeName .}
 Procedure VariableGroup( Kind: Class; Var Number: Longint;
                          Var LastVar, Typex: Ptr;
                          Var Statusx : StatusType; Stop: Symbols);
 Var
   Name: Longint;
   Varx: Ptr;
 begin
   ExpectName( Name, [comma1, colon1, shared1] + Stop);
   Define( Name, Kind, Varx);
   if Symbol = comma1 then
      begin
        Expect( comma1, [Name1] + Stop);
        VariableGroup( Kind, Number, LastVar, Typex, Statusx , Stop);
        number := number + 1
      end
   else
     begin
       Expect( Colon1, [Name1, Shared1] + Stop);
       if symbol = Shared1 then
         begin
           Expect( Shared1, [Name1] + Stop);
           Statusx := Shared;
         end
       else Statusx := Privatex;
       (*TypeName( Typex, Stop);*)
       ImplicitTypeDefinition( Typex, Stop);  (********************)
       LastVar := Varx;
       number := 1
     end;
   Varx^.VarType := Typex;
   Varx^.Status := Statusx;
 end; (* VariableGroup *)


 { ParameterGroup = VariableName GroupTail .
   GroupTail  = "," ParameterGroup | ":" [ SHARED ] ImplicitTypeDefinition.}
 Procedure ParameterGroup( Kind: Class; Var Number: Longint;
                          Var LastVar, Typex: Ptr;
                          Var Statusx : StatusType; Stop: Symbols);
 Var
   Name: Longint;
   Varx: Ptr;
 begin
   ExpectName( Name, [comma1, colon1, shared1, segment1] + Stop);
   Define( Name, Kind, Varx);
   if Symbol = comma1 then
      begin
        Expect( comma1, [Name1] + Stop);
        ParameterGroup( Kind, Number, LastVar, Typex, Statusx , Stop);
        number := number + 1
      end
   else
     begin
       Expect( Colon1, [Name1, Shared1, segment1] + Stop);
       if symbol = Shared1 then
         begin
           Expect( Shared1, [Name1, segment1] + Stop);
           Statusx := Shared;
         end
       else Statusx := Privatex;
       ImplicitTypeDefinition( Typex, Stop);
       LastVar := Varx;
       number := 1
     end;
   Varx^.VarType := Typex;
   Varx^.Status := Statusx;
 end; (* ParameterGroup *)


 { VariableDefinition = VariableGroup ";" .}
 Procedure VariableDefinition( Var LastVar: Ptr; Var Length: Longint; Stop:Symbols);
 Var
   number: Longint;
   Typex: Ptr;
   Status : StatusType;
 begin
   VariableGroup( Variable, number, LastVar, Typex, Status, [semicolon1] + Stop );
   Length:= number * TypeLength(Typex);
   Expect( semicolon1, Stop )
 end; (* VariableDefinition *)

 { VariableDefinitionPart = "Var" VariableDefinition [ VariableDefinition ]. }
 Procedure VariableDefinitionPart( Var Length: Longint; Stop: Symbols);
 Var
   Stop2: Symbols;
   LastVar: Ptr;
   More: Longint;
 begin
   Stop2 := [Name1] + Stop;
   Expect( Var1,Stop2);
   VariableDefinition( LastVar, Length, Stop2);
   while Symbol = Name1 do
     begin
        VariableDefinition( LastVar, More, Stop2);
        Length := Length + More
     end;
   VariableAddressing( Length, LastVar);
 end; (* VariableDefinitonPart *)

 { ParameterDefinition = ["Var"] VariableGroup . }
 Procedure ParameterDefinition( Var LastParam: Ptr; Var Length: Longint; Stop: Symbols);
 Var
   Number: Longint;
   Typex: Ptr;
   Status : StatusType;
 begin
   SyntaxCheck( [Var1, Name1] + Stop);
   if Symbol = Var1 then
     begin
       Expect( Var1, [Name1] + Stop);
       VariableGroup( VarParameter, Length, LastParam, Typex, Status, Stop)
     end
   else
     begin
       ParameterGroup( ValueParameter, Number, LastParam, Typex, Status, Stop);
       Length := Number * TypeLength( Typex)
     end
 end; (* ParameterDefinition *)

 { FormalParameterList = ParameterDefinition [ ";" ParameterDefinition ]}
 Procedure FormalParameterList( Var LastParam: Ptr;
                 Var Length: Longint; Stop : Symbols);
 Var
   Stop2: Symbols;
   More: Longint;
 begin
   Stop2 := [semicolon1] + Stop;
   ParameterDefinition( LastParam, Length, Stop2);
   while Symbol = semicolon1 do
     begin
       Expect( semicolon1, ParameterSymbols + Stop2);
       ParameterDefinition( LastParam, More, Stop2);
       Length := Length + More
     end;
   ParameterAddressing( Length, LastParam);
 end;


{ ProcedureDefinition = [SHARED]"Procedure" ProcedureName ProcedureBlock ";" .
  ProcedureBlock = ["(" FormalParameterList ")"] ";" Blockbody . }

 Procedure Blockbody( BeginLabel, VarLabel : Longint; Stop : Symbols); forward;

 Procedure ProcedureDefinition( Stop : Symbols);
 Var
   TaskOProced : SymbolType;
   Name: Longint;
   Proc: Ptr;
   ProcLabel, ParamLength, VarLabel, beginLabel,
   TempControlLabel, TempElementalLabel: Longint;
 begin
   TaskOProced := Symbol;

   if TaskOProced = shared1 then
     Expect( shared1,[Name1,LeftParenthesis1,SemiColon1] + BlockSymbols + Stop);

   Expect( Procedure1,[Name1,LeftParenthesis1,SemiColon1] + BlockSymbols + Stop);

   if TaskOProced = Shared1 then
     LevelPar := LevelPar + 1;

   ExpectName( Name, [LeftParenthesis1,SemiColon1] + BlockSymbols + Stop);

   if LevelPar > 0 then
     Define( Name, Taskx, Proc)
   else
     Define( Name, Procedur, Proc);

   Proc^.ProcLevel := BlockLevel;
   NewLabel( Proc^.ProcLabel);
   NewBlock;
   if Symbol = LeftParenthesis1 then
      begin
        Expect( LeftParenthesis1,ParameterSymbols + [RightParenthesis1,SemiColon1] + BlockSymbols + Stop);
        formalParameterList( Proc^.LastParam, ParamLength, [RightParenthesis1, SemiColon1] + BlockSymbols + Stop);
        Expect( RightParenthesis1, [SemiColon1] + BlockSymbols + Stop);
      end
   else  {No Parameter list}
      begin
        Proc^.LastParam := nil;
        ParamLength := 0
      end;
   NewLabel( VarLabel);
   NewLabel( BeginLabel);
   NewLabel( TempControlLabel);
   NewLabel( TempElementalLabel);

   Emit2( DefAddr2 ,Proc^.ProcLabel);
   Emit5( Procedure2, VarLabel, TempControlLabel, TempElementalLabel, BeginLabel);

   Expect( SemiColon1, [SemiColon1] + BlockSymbols + Stop);

   BlockBody( BeginLabel, VarLabel, [semicolon1] + Stop);


   if TaskOProced = shared1 then
     LevelPar := LevelPar - 1;

   Emit3( DefArg2, TempControlLabel, Block[BlockLevel].MaxTemp );
   Emit3( DefArg2, TempElementalLabel, Block[BlockLevel].ElementalMax );

   Emit2( EndProc2, ParamLength);

   Expect( SemiColon1, Stop);

   EndBlock

 end;

 { IndexedSelector = "[" Expression [ ":" Expression ] "]" }

 { IndexedSelector = "[" Expression "]". }
 Procedure Expression( Var Typex:Ptr; Stop:Symbols); forward;

 Procedure IndexedSelector( Var Typex: Ptr; Stop: Symbols);
 Var
   Type1, Type2, Objt : Ptr;
 begin
   Expect( leftbracket1, ExpressionSymbols + [colon1, rightbracket1] + Stop);
   Expression( Type1, [colon1, rightbracket1] + ExpressionSymbols + Stop);
   if symbol = colon1 then
     begin
       if Typex^.Kind = ArrayType then
         begin
           CheckTypes( Type1, Typex^.IndexType);
           Expect( colon1, [rightbracket1] + ExpressionSymbols + Stop);
           Expression( Type2, [rightbracket1] + ExpressionSymbols + Stop);
           CheckTypes( Type2, Typex^.IndexType);
           Emit5( SEGINIT2, Typex^.LowerBound, Typex^.UpperBound,  TypeLength(Typex^.ElementType), lineno );
           Pop( LevelPar, 1);
           Define(noname, SegmentType, Objt);
           Objt^.itemType := Typex^.ElementType;
           Typex := Objt;
         end
       else if Typex^.Kind = SegmentType then
         begin
           CheckTypes( Type1, TypeInteger);
           Expect( colon1, [rightbracket1] + ExpressionSymbols + Stop);
           Expression( Type2, [rightbracket1] + ExpressionSymbols + Stop);
           CheckTypes( Type2, TypeInteger);
           Emit3( SEGDYNINIT2, TypeLength(Typex^.itemType), lineno );
           Pop( LevelPar, 1);
         end
       else
         begin
           KindError( Typex);
           Typex := TypeUniversal
         end
     end
   else
     begin
       if Typex^.Kind = ArrayType then
         begin
           CheckTypes( Type1, Typex^.IndexType);
           Emit5( INDEX2, Typex^.LowerBound, Typex^.UpperBound, TypeLength(Typex^.ElementType), LineNo);
           Pop( LevelPar, 1);
           Typex := Typex^.ElementType
         end
       else if Typex^.Kind = SegmentType then
         begin
           (* a[i]  cuando es un segmento *)
           CheckTypes( Type1, TypeInteger);
           emit3( SEGINDEX2, TypeLength(Typex^.itemType), LineNo);
           Pop( LevelPar, 1);
           Typex := Typex^.itemType
         end
       else
         begin
           KindError( Typex);
           Typex := TypeUniversal
         end;
     end; (* not colon *)
   Expect( RightBracket1, Stop)
 end; (* IndexSelector *)

 { FieldSelector = "." FieldName . }
 Procedure FieldSelector( Var Typex: Ptr; Stop: Symbols);
 Var
   Found: Boolean;
   Fieldx: Ptr;
 begin
   Expect( Period1, [Name1] + Stop);
   if Symbol = Name1 then
     begin
       if Typex^.Kind = RecordType then
         begin
           Found := False;
           Fieldx:= Typex^.LastField;
           while Not Found and ( Fieldx <> nil) do
             if Fieldx^.Name <> Argument then
               Fieldx := Fieldx^.Previous
             else
               Found := True;
           if Found then
             begin
               Typex:= Fieldx^.FieldType;
               Emit2( FIELD2, Fieldx^.FieldDispl)
             end
           else
             begin
               Error( UnDefined3);
               Typex := TypeUniversal
             end
         end
       else
         begin
           KindError( Typex);
           Typex := TypeUniversal
         end;
       Expect( Name1, Stop)
     end
   else
     begin
       SyntaxError( Stop);
       Typex:= TypeUniversal
     end
 end; (* FieldSelector *)

 { VariableAccess = VariableName [ Selector ].
   Selector = IndexedSelector | FieldSelector . }
 Procedure Variableaccess( Var Typex: Ptr; Var Statusx: StatusType;
                           Var ParLevel : LongInt ; Stop: Symbols);
 Var
   Stop2: Symbols;
   Objt : Ptr;
   Level, Displ: Longint;
 begin
   if Symbol = Name1 then
     begin
       Stop2 := SelectorSymbols + Stop;
       Find( Argument, Objt);
       Expect( Name1, Stop2);
       if Objt^.Kind in Variables then
         begin
           if Objt^.RWStatus = ReadOnly then
             error(ReadOnly3)
           else
             begin
               Typex := Objt^.VarType;
               Level := BlockLevel - Objt^.VarLevel;
               Displ := Objt^.VarDispl;
               Statusx := Objt^.Status;
               ParLevel := Objt^.ParLevel;
               if Objt^.Kind = VarParameter then
                 Emit3( VARPARAM2, Level, Displ)
               else
                 Emit3( VARIABLE2, Level, Displ);
               Push( LevelPar, 1);
               if Typex^.Kind = SegmentType then
                 Emit2( VALUE2, TypeLength( Typex));
             end;
         end
       else
         begin
           KindError( Objt);
           Typex := TypeUniversal
         end;
       while Symbol in SelectorSymbols do
         if Symbol = LeftBracket1 then IndexedSelector(Typex, Stop2)
         else {Symbol = periord1 } FieldSelector(Typex, Stop2)
      end
   else
     begin
       SyntaxError( Stop);
       Typex := TypeUniversal
     end
 end; (* VariableAccess *)

 { SetConstructor = SetName "[" MemberGroup  "," MemberGroup" ! "]".
   MemberGroup = Expression | Expression ".." Expression .            }
 Procedure MemberGroup( Length : Longint; SetType : Ptr; Stop : Symbols);
 Var  ExprType1, ExprType2 : Ptr;
 begin
   Expression( ExprType1, Stop);
   CheckTypes( ExprType1, SetType^.BaseType );
   if Symbol = doublEdot1 then
     begin
       Expect(doublEdot1, [comma1, rightbracket1] + ExpressionSymbols + Stop);
       Expression( ExprType2, Stop);
       CheckTypes( ExprType2, SetType^.BaseType );
       Emit5( FILL2, SetType^.lowBound, SetType^.uppBound, Length, lineNo );
       Push( LevelPar, Length );
     end
   else
     begin
       Emit5( marked2, SetType^.lowBound, SetType^.uppBound, Length, lineNo );
       Push( LevelPar, Length );
     end
 end; (* MemberGroup *)


 Procedure SetConstructor( Length: Longint; SetType:Ptr ; Stop: Symbols);
 Var ExprType1, ExprType2 : Ptr;
 begin
   Expect( Name1,[leftbracket1, doublEdot1, comma1, rightbracket1] + ExpressionSymbols + Stop);
   Expect( leftbracket1, [doublEdot1, comma1, rightbracket1] + ExpressionSymbols + Stop);
   if Symbol in ExpressionSymbols then
     begin
       MemberGroup( Length, SetType, [doublEdot1, comma1,rightbracket1] + ExpressionSymbols + Stop);
       while Symbol = comma1 do
         begin
           Expect( comma1,[doublEdot1, comma1, rightbracket1] + ExpressionSymbols + Stop);
	   MemberGroup( Length, SetType, [doublEdot1, comma1, rightbracket1] + ExpressionSymbols + Stop);
	   Emit2( or2, Length);
	 end
     end
   else { el connjunto vacio en el top }
     begin
       Emit2( FILLZERO2, length );
       push( LevelPar, length );
     end;
   Expect( rightbracket1, Stop)
 end; (* SetConstructor *)

 { Factor = Constant | VariableAccess | "(" Expression ")" | "Not" Factor | SetConstructor. }
 Procedure Factor( Var Typex: Ptr; Stop: Symbols);
 Var
   Objt: Ptr;
   Value ,
   ParLevel,
   Length: LongInt;
   Status: StatusType;
 begin
   if Symbol = Numeral1 then
     begin
       Constant( Value, Typex, Stop);
       Emit2( CONSTANT2, Value);
       Push( LevelPar, 1)
     end
   else if Symbol = Name1 then
     begin
       Find( Argument, Objt);
       if Objt^.Kind = Constantx then
	 begin
	   Constant( Value, Typex, Stop);
	   Emit2( CONSTANT2, Value);
	   Push( LevelPar, 1)
	 end
       else if ( Objt^.Kind in Variables) then
	 begin
	   if ( Objt^.Name = Name0 ) then
             begin
               Expect( Name1, SelectorSymbols + Stop);
               Typex := Objt^.VarType;
   	       Emit2( PushName2, LineNo);
	       Push( LevelPar, 1);
             end
	   else if ( Objt^.Name = counter0 ) then
             begin
               Expect( Name1, SelectorSymbols + Stop);
               Typex := Objt^.VarType;
   	       Emit1( PushCounter2);
	       Push( LevelPar, 1);
             end
           else
	     begin
               Variableaccess( Typex, Status, ParLevel, Stop);
               if typex^.kind <> segmentType then
                 begin
	           Length := TypeLength( Typex);
	           Emit2( VALUE2, Length);
    (*             El Share se emite en actualparamenterlist no aqu *)
    (*               if Status = Shared then
                     Emit2( SHARED2, Length)
                   else { Status = Private } *)

                     if ((Status = Privatex) and (ParLevel <> LevelPar)) then
                       Error(Status3);
	           Push( LevelPar, Length - 1);
                 end
	     end
	 end
       else if Objt^.Kind = SetType then
	 begin
	   Typex:= Objt;
	   Length := TypeLength(Objt);
	   SetConstructor( Length, Objt, Stop);
	 end
       else
	 begin
	   KindError( Objt);
	   Typex := TypeUniversal;
	   Expect( Name1, Stop)
	 end
     end
   else if Symbol = leftParenthesis1 then
     begin
       Expect( LeftParenthesis1, ExpressionSymbols+[rightParenthesis1] + Stop);
       Expression( Typex, [rightParenthesis1] + Stop);
       Expect( RightParenthesis1, Stop)
     end
   else if Symbol = Not1 then
     begin
       Expect( Not1, FactorSymbols + Stop);
       Factor( Typex, Stop);
       if ( Typex <> TypeBoolean) and (Typex <> TypeInteger) and
	  ( Typex^.Kind <> SetType ) then
	  begin
	    Error( Type3);
	    Typex := TypeUniversal;
	  end;
       Length := TypeLength( Typex);
       Emit2( NOT2, Length);
     end
   else if Symbol = Random1 then
     begin
       Expect( Random1, FactorSymbols + Stop);
       Factor( Typex, Stop);
       if ( Typex <> TypeInteger) then
	 begin
	   Error( Type3);
	   Typex := TypeUniversal;
         end;
       Length := TypeLength( Typex);
       Emit2( RANDOM2, Length);
     end
   else if symbol = size1 then
     begin
       Expect( size1, FactorSymbols + Stop);
       Factor( Typex, Stop);
       if ( Typex^.kind <> SegmentType) then
	 begin
	   Error( Type3);
	   Typex := TypeUniversal;
         end;
       typex:= TypeInteger;
       Emit1( Size2);
     end
   else
     begin
       SyntaxError( Stop);
       Typex := TypeUniversal
     end
 end; (* factor *)

 { Term = Factor [ MultiplyingOperator Factor ] .
   MultiplyingOperator = "*" | "div" | "mod" | "and" | "shl" | "shr" | "xor"| "min" | "max". }
 Procedure Term( Var Typex: Ptr; Stop: Symbols);
 Var
   Stop2: Symbols;
   Operator : SymbolType;
   Type2: Ptr;
   Length: Longint;
 begin
   Stop2 := MultiplySymbols + Stop;
   Factor(Typex, Stop2);
   while Symbol in MultiplySymbols do
     begin
       Operator := Symbol;
       Expect(Symbol, FactorSymbols + Stop2);
       Factor(Type2, Stop2);
       if ((Typex = TypeInteger) or (Typex^.Kind = SubrangeType)) then
         begin
           if (Typex = TypeInteger) and (Type2 = TypeInteger) then
             CheckTypes(Typex, Type2)
           else if (Typex = TypeInteger) and ( Type2^.Kind = SubrangeType) then
             CheckTypes(Typex, Type2^.TipoElemt)
           else if (Typex ^.Kind = SubrangeType) and ( Type2 = TypeInteger) then
             CheckTypes( Typex^.TipoElemt, Type2 )
           else if (Typex^.Kind = SubrangeType) and ( Type2^.Kind = SubrangeType) then
             CheckTypes( Typex^.TipoElemt, Typex^.TipoElemt);
	   if Operator = asterisk1 then Emit1(Multiply2)
	   else if Operator = div1 then Emit1(divide2)
	   else if Operator = max1 then Emit1(max2)
	   else if Operator = min1 then Emit1(min2)
	   else if Operator = mod1 then Emit1(modulo2)
           else if Operator = and1 then Emit2(and2, 1)
           else if Operator = shl1 then Emit2(shl2, 1)
           else if Operator = shr1 then Emit2(shr2, 1)
           else if Operator = xor1 then Emit2(xor2, 1);
           Pop( LevelPar , 1)
         end
       else if Typex = TypeBoolean then
         begin
           CheckTypes(Typex, Type2);
           if Operator = and1 then Emit2(and2, 1)
           else {aritmetic Operator o shl o shr o xor }
             TypeError(Typex);
           Pop( LevelPar , 1)
         end
       else if Typex^.Kind = SetType then
         begin
           Length := TypeLength(Typex);
           if (Type2^.Kind = StandardType) or ( Type2^.Kind = SubrangeType ) then
             begin
               if Typex^.BaseType^.Kind = SubrangeType then
                 if Type2^.Kind  = SubrangeType then
                   CheckTypes( Type2^.TipoElemt, Typex^.BaseType^.TipoElemt)
                 else CheckTypes( Type2, Typex^.BaseType^.TipoElemt)
               else TypeError(Typex^.BaseType);

               if Operator = shl1 then Emit2(shl2, Length)
               else if Operator = shr1 then Emit2(shr2, Length)
               else TypeError(Type2);
               Pop(LevelPar, 1);

             end
           else
             begin
               CheckTypes(Typex,Type2);
               if Operator = asterisk1 then Emit2(and2, Length)
               else {cualquier otro Operador} TypeError(Typex);
               Pop( LevelPar , Length)
             end
         end
       else
         TypeError(Typex);
     end (* while *)
 end; (* Term *)

 { SimpleExpression = [ SignOperator ] Term [ AddingOperator Term ].
   SignOperator = "+" | "-" |"&".
   AddingOperator = "+" | "-" | "or" }
 Procedure SimpleExpression(Var Typex: Ptr; Stop: Symbols);
 Var
   Stop2: Symbols;
   Operator: SymbolType;
   Type2: Ptr;
   Length: Longint;
 begin
   Stop2 := AddSymbols + Stop;
   SyntaxCheck( SignSymbols + TermSymbols + Stop2);
   if Symbol in SignSymbols then
      begin
        Operator := Symbol;
        if Operator = andpersand1 then
          begin
            Emit2( Constant2, 1);
            Push(LevelPar, 1);
          end;
        Expect(Symbol, TermSymbols + Stop2);
        Term(Typex,Stop2);
        if Operator = minus1 then Emit1(minus2)
        else if Operator = andpersand1 then
          begin
            Emit2( shl2, 1);
            Pop( LevelPar, 1);
          end;
      end
   else Term(Typex, Stop2);
   while Symbol in AddSymbols do
      begin
        Operator := Symbol;
        Expect(Symbol, TermSymbols + Stop);
        Term(Type2, Stop2);
        if ( Typex = TypeInteger ) or
           ( Type2^.Kind = SubrangeType )  then
           begin
              if Operator = plus1 then Emit1(Add2)
              else if Operator = minus1 then Emit1(subtract2)
              else if Operator = or1 then Emit2(or2, 1);
              Pop( LevelPar , 1)
           end
        else if Typex = TypeBoolean then
           begin
              CheckTypes(Typex, Type2);
              if Operator = or1 then Emit2(or2, 1)
              else {aritmetic Operator } TypeError(Typex);
              Pop( LevelPar , 1)
           end
        else if Typex^.Kind = SetType then
           begin
             CheckTypes(Typex,Type2);
             Length:= TypeLength(Typex);
             if Operator = plus1 then Emit2(or2, Length)
             else if Operator = minus1 then Emit2(xor2, Length)
             else {cualquier otro Operador} TypeError(Typex);
             Pop( LevelPar , Length)
           end
        else TypeError(Typex)
      end
 end;

 { Expression = SimpleExpression
               [ RelationalOperator SimpleExpression] .
   RelationalOperator = "<" | "=" | ">" | "<=" | "<>" | ">=" | "in". }
 Procedure Expression(Var Typex: Ptr; Stop: Symbols);
 Var
   Length : Longint;
   Operator: SymbolType;
   Type2: Ptr;
 begin
   SimpleExpression(Typex, RelationSymbols + Stop);
   if Symbol in RelationSymbols then
      begin
        Operator := Symbol;
        Expect(Symbol, SimpleExprSymbols + Stop);
        SimpleExpression(Type2, Stop);
        if (Typex^.Kind = StandardType) or
           ( Typex^.Kind = SubrangeType ) then
           begin
              if Type2^.Kind = SetType then
                 begin
		   CheckTypes( Typex, Type2^.BaseType);
		   Length:= TypeLength(Type2);
		   if Operator = in1 then
		    begin
		   	Emit2( in2, Length);
		   	Pop(LevelPar, Length);
		    end
		   else {cualquier otro Operador} TypeError(Type2);
		 end
	       else if (Type2^.Kind = StandardType) or
                      (Type2^.Kind = SubrangeType) then
                 begin
                   if (Type2 ^.Kind = SubrangeType) then
                     if ( Typex^.Kind = SubrangeType ) then
                       CheckTypes( Typex^.TipoElemt,
                                          Type2^.TipoElemt)
                     else
                       CheckTypes( Typex, Type2^.TipoElemt);
                   if Operator = less1 then Emit2(less2,1)
                   else if Operator = equal1 then Emit2(equal2, 1)
                   else if Operator = greater1 then Emit2(greater2,1)
                   else if Operator = Notgreater1 then
                                      Emit2(Notgreater2,1)
                   else if Operator = Notequal1 then
                                      Emit2(Notequal2, 1)
                   else { Operator = Notless1 } Emit2(Notless2,1);
                   Pop( LevelPar , 1)
                 end
               else TypeError(Type2);
           end
        else if Typex^.Kind = SetType then
           begin
              CheckTypes(Typex,Type2);
              Length:= TypeLength(Typex);
              if Operator = less1 then Emit2( less2, Length)
              else if Operator = equal1 then Emit2(equal2, Length)
              else if Operator = greater1 then Emit2(greater2, Length)
              else if Operator = Notgreater1 then
                                 Emit2(Notgreater2, Length)
              else if Operator = Notequal1 then
                                 Emit2(Notequal2, Length)
              else { Operator = Notless1 } Emit2(Notless2, Length);
              Pop( LevelPar , 2*Length)
           end
        else TypeError(Typex);
        Typex := TypeBoolean
      end
 end;

{ IOStatement = "read" "(" Variableaccess ")" |
                "readln" "(" Variableaccess ")" |
                "write" "(" ArgumentList ")" |
                "writeln" "(" ArgumentList ")" }
{   ArgumentList = OneArgument ! "," OneArgument ! }
{   OneArgument = Chain | Expression }
{   Chain = Character ! Character ! }
{   Character = 0 |.. | 255  }
Procedure Chain( Var len, numchar : Longint ; Stop : Symbols);
Type
  PackedChar = Array[1..4] of byte;
Var
  Arg : packedChar;
  i : byte;
  EmitirCadena:Boolean;
 begin
   len := 0;
   i := 0;
   numchar := 0;
   repeat
       i := i + 1;
       Arg[i] := Argument;
       Expect( char1, [char1] + Stop );
       numChar := numChar + 1;
       if ((i < 4) and (Symbol <> char1)) then EmitirCadena := True
       else if i = 4 then EmitirCadena := True
       else EmitirCadena := False;
       if EmitirCadena then
         begin
           Emit2( Constant2, LongInt(Arg));
           len := len + 1;
           i := 0;
         end;
   until Symbol <> char1 ;
   Push(LevelPar, len);
 end;

 {   OneArgument = Chain | Expression }
 Procedure OneArgument( Stop : Symbols);
 Var
   len, numChar : Longint;
   Typex : Ptr;
 begin
   if Symbol = apostrOphe1 then
     begin
       Expect( apostrOphe1, [char1 , apostrOphe1 ] + Stop);
       if Symbol = apostrOphe1 then len := 0
       else chain( len,numChar, [apostrOphe1] + Stop );
       Expect( apostrOphe1, Stop);
       Emit3( writeStr2, len , numChar);
       Pop(LevelPar, len);
     end
   else if Symbol in ExpressionSymbols then
     begin
       Expression( Typex, Stop );
       Emit1(writeInt2);
       CheckTypes( Typex, TypeInteger);
       Pop(LevelPar, 1);
     end
   else SyntaxError( Stop );
 end;

 {   ArgumentList = OneArgument ! "," OneArgument ! }
 Procedure ArgumentList(Stop : Symbols );
 begin
   OneArgument( [comma1] + Stop);
   while Symbol = comma1 do
     begin
       Expect( comma1, [comma1]+ExpressionSymbols+Stop);
       OneArgument( [comma1] + Stop );
     end;
 end;

{ IOStatement = "read" "(" Variableaccess ")" |
                "readln" "(" Variableaccess ")" |
                "write" "(" ArgumentList ")" |
                "writeln" "(" ArgumentList ")" }

 Procedure IOStatement (Stop : Symbols);
 Type
   PackedChar = Array[1..4] of byte;
 Var
   Arg : packedChar;
   Stop2: Symbols;
   Status : StatusType;
   Name,
   ParLevel: Longint;
   Typex: Ptr;
 begin
   {Symbol = (standard Procedure) Name1 }
   Stop2 := [rightParenthesis1] + Stop;
   Name := Argument;
   Expect( Name1, ExpressionSymbols + Stop2);
   if Symbol = LeftParenthesis1 then
     begin
       Expect( LeftParenthesis1, [Apostrophe1, Comma1] + ExpressionSymbols + Stop2);
       if (Name = read0) or (Name = readln0) then
         begin
           Variableaccess( Typex, Status, ParLevel, Stop2);
           CheckTypes( Typex, TypeInteger);
           if Status = Shared then
             Emit1( READINT2)
           else { Status = Private }
             Emit1( PRIVATEREADINT2);
           Pop( LevelPar, 1 );
         end
       else if (Name = write0) or (Name = writeln0 ) then
         ArgumentList( [Apostrophe1] + Stop2 );
       if Name = writeln0 then
         begin
           Arg[1]:= 13;
           Arg[2]:= 10;
           Arg[3]:= 0;
           Arg[4]:= 0;
           Emit2( CONSTANT2, LongInt(Arg));
           Push( LevelPar, 1);
           Emit3( WRITESTR2, 1 , 2);
           Pop( LevelPar, 1);
         end;
       Expect( RightParenthesis1, Stop)
     end
   else
     begin
       if Name = writeln0 then
         begin
           Arg[1]:= 13;
           Arg[2]:= 10;
           Emit2( CONSTANT2, LongInt(Arg));
           Emit3( WRITESTR2, 1 , 2);
         end
       else if Name = Readln0 then Emit1( READLNX2 )
       else SyntaxError( Stop );
     end;
 end; (* IOStatement *)

{ TimeStatement = "SetTime" "(" Variableaccess ")" |
                  "GetTime" "(" Variableaccess "," Expression ")" }
 Procedure TimeStatement( Stop : Symbols);
 var
   Stop2 : Symbols;
   Name : Integer;
   Status : StatusType;
   ParLevel : LongInt;
   Typex : Ptr;
 begin
   (* Symbol = (Standard Procedure) Name1 *)
   Stop2 := [RightParenthesis1, comma1] + Stop;
   Name := Argument;
   Expect( Name1, ExpressionSymbols + Stop2 );
   Expect( LeftParenthesis1, ExpressionSymbols + Stop2 );
   if Name = SetTime0 then
     begin
       VariableAccess( Typex, Status, ParLevel, ExpressionSymbols + [RightParenthesis1] + Stop);
       CheckTypes( Typex, TypeInteger );
       if Status = Shared then
         Emit1( SETTIME2 )
       else { Status = Private }
         begin
           if ParLevel <> LevelPar then Error( Status3);
           Emit1( PRIVATESETTIME2);
         end;
       Pop( LevelPar, 1);
     end
   else (* Name = GetTime0 *)
     begin
       VariableAccess( Typex, Status, ParLevel, ExpressionSymbols + Stop2 );
       CheckTypes( Typex, TypeInteger );
       Expect( comma1, ExpressionSymbols + [RightParenthesis1]+ Stop);
       Expression( Typex, [RightParenthesis1]+ Stop);
       CheckTypes( Typex, TypeInteger );
       if Status = Shared then
         Emit1( GETTIME2 )
       else
         begin
           if ParLevel <> LevelPar then Error( Status3);
           Emit1( PRIVATEGETTIME2 );
         end;
       Pop( LevelPar, 2);
     end;
   Expect( RightParenthesis1, Stop);
 end; (* TimeStatement *)

{ DebugStatement = "debug" "(" Expression ")" }
 Procedure DebugStatement( Stop : Symbols);
 var
   Stop2 : Symbols;
   Name : Integer;
   Status : StatusType;
   ParLevel : LongInt;
   Typex : Ptr;
 begin
   (* Symbol = (Standard Procedure) Name1 *)
   Stop2 := [RightParenthesis1] + Stop;
   Name := Argument;
   Expect( Name1, ExpressionSymbols + Stop2 );

   Expect( LeftParenthesis1, ExpressionSymbols + Stop2 );
   if Name = Debug0 then
     begin
       Expression( Typex, Stop2);
       CheckTypes( Typex, TypeBoolean );
       Emit1( DEBUG2 );
       Pop( LevelPar, 1);
     end; (* else kind of name invalid *)
   Expect( RightParenthesis1, Stop);
 end; (* DebugStatement *)

{ BroadcastStatement = "Broadcast" "(" Variableaccess ")" |
                       "size" "(" Variableaccess ")" }

 procedure BroadCastStatement( Stop : symbols);
 var stop2 : symbols;
     name : integer;
     typex : Ptr;
     Status : StatusType;
     ParLevel : LongInt;
 begin
   (* Symbol = (Standard Procedure) Name1 *)
   Stop2 := [RightParenthesis1] + Stop;
   Name := Argument;
   Expect( Name1, ExpressionSymbols + Stop2 );
   Expect( LeftParenthesis1, ExpressionSymbols + Stop2 );
   if Name = broadcast0 then
     begin
       VariableAccess( Typex, Status, ParLevel, Stop2);
       if typex^.kind <> segmentType then
         emit2( BROADCAST2, TypeLength(Typex))
       else
         Emit2( SEGBROADCAST2, TypeLength(Typex^.itemType));
       Pop( LevelPar, 2);
     end;
   Expect( RightParenthesis1, Stop);
 end; (* broadcastStatement *)



 { StandardStatement -> IOStatement | TimeStatement | RandomStatement
                        BroadcastStatement                             }

 Procedure StandardStatement(Stop : symbols);
 var name : Longint;
 begin
   Name := argument;
   if ( (Name = Read0) or (Name = Write0)
         or (Name = Readln0) or (Name = Writeln0) ) then
     IOStatement(Stop)
   else if ( (Name = SetTime0) or (Name = GetTime0) ) then
     TimeStatement( Stop )
   else if Name = Randomize0 then
     begin
       expect(name1, Stop);
       emit1(randomize2)
     end
   else if Name = debug0 then
     begin
       expect(name1, Stop);
       emit1(debug2)
     end
   else if (Name = broadcast0) then
     BroadCastStatement( Stop)
   else
     SyntaxError(Stop);
 end; (* StandardStatement *)

 {ActualParameterList = [ ActualParameterList "," ] ActualParameter.
  ActualParameter = Expression | VariableAccess . }
 Procedure ActualParameterList( LastParam: Ptr; Var Length: Longint; Stop: Symbols);
 Var
   Typex: Ptr;
   Status: StatusType;
   Leng,
   ParLevel,
   More: Longint;
 begin
   { LastParam <> nil }
   if LastParam^.Previous <> nil then
     begin
       ActualParameterList( LastParam^.Previous, More, [Comma1] + ExpressionSymbols + Stop );
       Expect( Comma1, ExpressionSymbols + Stop)
     end
   else More := 0;
   if LastParam^.Kind = ValueParameter then
     begin
       Expression( Typex, Stop);
       Leng := TypeLength( Typex);
       Length := Leng + More;
       if LastParam^.Status = Shared then
           Emit2( SHARED2, Leng);
     end
   else { LastParam^.Kind = VarParameter }
     begin
       Variableaccess( Typex, Status, ParLevel, Stop);
       if LastParam^.Status <> Status then
         Error( Status3);
       if LastParam^.Status = Shared then
         Emit2( SHARED2, 1);
       Length:= 1 + More
     end;
   CheckTypes( Typex, LastParam^.VarType);
 end; (* ActualParameterList *)

 { ProcedureStatement = IOStatement |
                        ProcedureName [ "(" ActualParameterList ")" ]  |
                        TaskName [ "(" ActualParameterList ")" ]. }
 Procedure ProcedureStatement(Stop: Symbols);
 Var
   Stop2: Symbols;
   Proc: Ptr;
   ParamLength: Longint;
   CallTaskInSeq : boolean;
 begin
   { Symbol = (Procedure) Name1 }
   CallTaskInSeq := false;

   Find( Argument, Proc );
   if Proc^.Kind = StandardProc then
     begin
       (*
       if LevelPar <> 0 then KindError(Proc)
       else 14-10-92 OJO, ESTO ES UN PARCHE PARA PERMITIR LA DEPURACION
       *)
       StandardStatement(Stop)
     end
   else if Proc^.Kind in Procedures then
     begin

       (* si se llama a un subprograma declarado como un procedure desde
        un parallel no se puede permitir la llamada. *)

       if ( levelpar > 0 ) and ( Proc^.Kind = Procedur ) then
         Error( Proc3 );

       (* si se llama a una task en secuencial, se debe activar de la
        siguiente forma:
       		       task suma;
   		       begin
   		       end;
   		       ......
   		       begin        |     begin
   			 ......     |       ..........
   		       	            |	   parallel 0..0 do
   		       	 suma;      |       suma;
   		       end.         |     end.                 *)

   	 if ( LevelPar = 0 ) and ( Proc^.Kind = taskx ) then
   	   begin
   	     CallTaskInSeq := true;
             (*15-10-93*)
   	     (* Emit1( PushPattern2 ); *)
   	     Emit2( SinglePattern2 , 0 );
   	     LevelPar := LevelPar + 1;
   	   end;

   	 if Proc^.LastParam <> nil then
   	   begin
   	     Stop2 := [rightParenthesis1] + Stop;
   	     Expect( Name1,[leftParenthesis1] + ExpressionSymbols +Stop2);
   	     Expect( leftParenthesis1, ExpressionSymbols + Stop2);
   	     actualParameterlist( Proc^.LastParam, ParamLength, Stop2);
   	     Expect( rightParenthesis1, Stop)
   	   end
   	 else { No Parameter list }
   	   begin
   	     Expect( Name1, Stop);
   	     ParamLength := 0
   	   end;
   	 (* FELIX *)
(* 	 if ( Argument = input0) or (Argument = output0) then
   	   begin
   	     Emit1(Active2);
   	     Emit3(Proccall2, BlockLevel - Proc^.ProcLevel, Proc^.ProcLabel);
   	     Emit1(Active2)
   	   end
   	 else
     	   Emit3( Proccall2, BlockLevel - Proc^.ProcLevel, Proc^.ProcLabel);
*)
   	 (* FELIX *)

         (* 23-12-93 *)


         Emit3( ProcCall2, BlockLevel - Proc^.ProcLevel, Proc^.ProcLabel);

   	 Push( LevelPar, 3);
   	 Pop( LevelPar, ParamLength + 3);


   	 if CallTaskInSeq then
   	   begin
             (* 15-10-92 *)
             LevelPar := LevelPar - 1;
   	     Emit1( EndSinglePattern2 );
   	     Pop( 0, MaxRecords );
   	   end;

     end
 end;


 { AssignmentStatement = VariableAccess [":=" | ".="] Expression . }
 Procedure AssignmentStatement( Stop: Symbols);
 Var
   isprivate : boolean;
   VarType, ExprType : Ptr;
   ParLevel, Length : Longint;
   Status : StatusType;
 begin
   isPrivate := false;
   Variableaccess( VarType, Status, ParLevel, [becomes1, dotbecomes1] + ExpressionSymbols + Stop);
   if symbol = becomes1 then
     Expect( Becomes1, ExpressionSymbols + Stop)
   else
     begin
       Expect( dotBecomes1, ExpressionSymbols + Stop);
       isPrivate := true;
     end;
   Expression( ExprType, Stop);
   CheckTypes( VarType, ExprType);
   Length := TypeLength( ExprType);
   if VarType^.Kind = SegmentType then
     begin
       if Status = Shared then
         begin
           if isPrivate then
             Emit3( PRIVATESEGASSIGN2, TypeLength(VarType^.itemtype),lineno)
           else
             Emit3( SEGASSIGN2, TypeLength(VarType^.itemtype),lineno)
         end
       else { Status = Private }
         begin
           if ParLevel <> LevelPar then Error( Status3);
           Emit2( PRIVATESEGASSIGN2, lineno);
           if isPrivate then Error( PrivateAssig3);
         end;
       Pop( LevelPar , 2 * Length)
     end
   else
     begin
       if Status = Shared then
         begin
           if isPrivate then
             Emit2( PRIVATEASSIGN2, Length)
           else
             Emit2( ASSIGN2, Length)
         end
       else { Status = Private }
         begin
           if ParLevel <> LevelPar then Error( Status3);
           Emit2( PRIVATEASSIGN2, Length);
           if isPrivate then Error( PrivateAssig3);
         end;
       Pop( LevelPar , 1 + Length)
     end
 end;


 Procedure Statement( Stop:Symbols); forward;

(* ParallelStatemente =
   "Parallel" Expression..Expression [ THRESHOLD Constant ] "do" Statement .*)
(* ParallelStatemente =
   "Parallel" [ THRESHOLD Constant ] "do" TaskName ["(" ActualParameterList ")"] "||"
    TaskName ["(" ActualParameterList ")"]
    { "||" TaskName ["(" ActualParameterList ")"] } ";"
*)

 Procedure ParallelStatement( Stop : Symbols);
 Var
	Stop2 : Symbols;
        thresholdvalue : Longint;

        (* ParallelStatemente =
        "Parallel" Expression..Expression [ THRESHOLD Constant ] "do" Statement .*)
	Procedure ParallelStatementDoubleDot( Stop : Symbols);
	Var
	  Label1, Value : Longint;
	  NameType, ExprType1, ExprType2, Typex : Ptr;
	begin
	  Expression( ExprType1, [DoubleDot1, Do1, Threshold1] +
				 ExpressionSymbols +  StatementSymbols + Stop);

	  Expect( doubledot1, [ Do1, Threshold1] + ExpressionSymbols
				    + StatementSymbols + Stop);

	  Expression (ExprType2, [Do1, Threshold1]+
                                 ConstantSymbols + StatementSymbols + Stop);

	  CheckTypes(ExprType1, ExprType2);

          Pop( LevelPar, 2 * TypeLength(ExprType1));

          ThresholdValue := 1;
          if ( Symbol = Threshold1) then
            begin
              Expect( Threshold1, ConstantSymbols + [do1] + StatementSymbols + Stop);
              Constant( Value, Typex, [do1] + StatementSymbols + Stop);
              CheckTypes(Typex, TypeInteger);
              if Value < 1 then error(Threshold3)
              else ThresholdValue := Value;
            end;


	  NewLabel( Label1 );

	  if LevelPar = 0 then Emit3( Pattern2 , Label1, ThresholdValue)
	  else Emit3( NestedPattern2, Label1, ThresholdValue);

          (*15-10-93*) (* pattern y Nestedpattern incluyen un PushPattern *)
	  Push( 0, MaxRecords);

	  Expect( do1, StatementSymbols + Stop);
	  LevelPar := LevelPar + 1;
	  Statement(Stop);

          (* 15-10-93 *)
          LevelPar := LevelPar - 1;
          IF LevelPar > 0 then Emit1( EndNestedPattern2 )
          else Emit1( EndPattern2 );
	  Pop( 0, MaxRecords);


	  Emit2( DefAddr2, Label1 );
	end;

        (* ParallelStatemente =
           "Parallel" [ THRESHOLD Constant ] "do" TaskName ["(" ActualParameterList ")"] "||"
            TaskName ["(" ActualParameterList ")"]
            { "||" TaskName ["(" ActualParameterList ")"] } ";"
        *)
	Procedure ParallelStatementDoublebar( Stop : Symbols);
	Var
		Label1, ActLabel, NumAct,
		NameTask,
		ParamLength, Value : Longint;
		Proc, Typex : Ptr;
		Stop2 : Symbols;
	begin
          ThresholdValue := 1;

          if ( Symbol = Threshold1) then
            begin
              Expect( Threshold1, ConstantSymbols + [do1, doublebar1, semicolon1 ] + ExpressionSymbols + Stop );
              Constant( Value, Typex, [do1, doublebar1, semicolon1 ] + ExpressionSymbols + Stop );
              CheckTypes(Typex, TypeInteger);
              if Value < 1 then error(Threshold3)
              else ThresholdValue := Value;
            end;

	  Expect( do1, [doublebar1, semicolon1 ] + ExpressionSymbols + Stop);

	  NewLabel( ActLabel );
	  Emit2( Constant2, 0 );
	  Emit2( PushConst2, ActLabel );

	  NewLabel( Label1 );
	  if LevelPar = 0 then Emit3( Pattern2 , Label1, ThresholdValue)
	  else Emit3( NestedPattern2, Label1, ThresholdValue);

          (*15-10-93*) (* pattern y Nestedpattern incluyen un PushPattern *)
	  Push( 0, MaxRecords);

          LevelPar := LevelPar + 1;

          { Se recupera antes de la llamada a la task }
          (* 15-10-93 *)
	  (* Emit1( pushPattern2 );
             Push( 0, MaxRecords); *)

	  if symbol = Name1 then
	    begin
	      Find( Argument, Proc );
	      if Proc^.Kind in Procedures then
		begin
		  if Proc^.LastParam <> nil then
		    begin
		      Stop2 := [rightParenthesis1, doublebar1, semicolon1 ] +
					  ExpressionSymbols + Stop;
		      ExpectName( NameTask, [leftParenthesis1] + Stop2);
		      Emit1(Pushpattern2);
		      Push( 0, MaxRecords);
		      Emit2( SingleControl2, 0 );
		      Expect(leftParenthesis1, Stop2);
		      actualParameterlist( Proc^.LastParam, ParamLength, Stop2);
		      Expect( rightParenthesis1, Stop2);
		      Emit1( PopPattern2 );
		      Pop( 0, MaxRecords);
		    end
		  else { No Parameter list }
		    begin
		      ExpectName( NameTask, Stop2);
		      ParamLength := 0
		    end;
	     Expect( doublebar1, Stop2 );
 	     if ( symbol = Name1 ) and ( Argument = NameTask ) then
	       begin
		 Find( Argument, Proc );
		 if Proc^.Kind in Procedures then
		   begin
		     if Proc^.LastParam <> nil then
		       begin
			 Expect( Name1, [leftParenthesis1] + Stop2);
			 Emit1(Pushpattern2);
			 Push( 0, MaxRecords);
			 Emit2( SingleControl2, 1 );
			 Expect(leftParenthesis1, Stop2);
			 actualParameterlist( Proc^.LastParam, ParamLength, Stop2);
			 Expect( rightParenthesis1, Stop2);
			 Emit1( PopPattern2 );
			 Pop( 0, MaxRecords);
		       end
		     else { No Parameter list }
		       begin
			 Expect( Name1, Stop2);
			 ParamLength := 0
		       end;
		     NumAct := 2;
		     while Symbol = doublebar1 do
		       begin
			 Expect( doublebar1, Stop2 );
			 if ( symbol = Name1 ) and ( Argument = NameTask ) then
			   begin
		 	     Find( Argument, Proc );
			     if Proc^.Kind in Procedures then
			       begin
				 if Proc^.LastParam <> nil then
				   begin
				     Stop2 := [rightParenthesis1, doublebar1, semicolon1 ] +
				               ExpressionSymbols + Stop;
				     Expect( Name1, [leftParenthesis1] + Stop2);
				     Emit1(Pushpattern2);
				     Push( 0, MaxRecords);
				     Emit2( SingleControl2, NumAct );
				     Expect(leftParenthesis1, Stop2);
				     actualParameterlist( Proc^.LastParam, ParamLength, Stop2);
				     Expect( rightParenthesis1, Stop2);
				     Emit1( PopPattern2 );
				     Pop( 0, MaxRecords);
			           end
			         else { No Parameter list }
			           begin
				     Expect( Name1, Stop2);
				     ParamLength := 0
				   end
			   end (* Proc^.Kind in Procedures *)
			 else
			   begin
			     KindError(Proc);
			     Expect(Name1, Stop)
                           end
		       end { if symbol = Name1 and Argument = taskName }
		     else Error( paralleldo3 );
		     NumAct := NumAct + 1;
		   end; { While symbol in doublebar }

		   Emit3(DefArg2, ActLabel, NumAct - 1 );

                   (* 15-10-93 *)
		   (* Emit1( popPattern2 va con el pushpatter de arriba ; *)

		       Emit3(Proccall2, BlockLevel - Proc^.ProcLevel, Proc^.ProcLabel);
		       Push(LevelPar, 3);
		       Pop( LevelPar, ParamLength + 3);


                       (* 15-10-93*)
                       LevelPar := LevelPar - 1;
                       IF LevelPar > 0 then Emit1( EndNestedPattern2 )
                       else Emit1( EndPattern2 );
		       Pop( 0, MaxRecords);

		       Emit2( DefAddr2, Label1 );

		 end { is a Procedure Name }

		   else
		     begin
		       KindError(Proc);
		       Expect(Name1, Stop)
		     end
	    end  { if symbol = Name1 and Argument = taskName }
				 else Error( paralleldo3 );
			  end {is a procedure Name }
			else
			  begin
				 KindError(Proc);
				 Expect(Name1, Stop)
			  end
		 end { if symbol = Name1 }
	  else SyntaxError( Stop );
	end;

 begin
	Stop2 := [ DoubleDot1, Threshold1, Do1, DoubleBar1, semicolon1] +
                 ExpressionSymbols + StatementSymbols + Stop;
	Expect( Parallel1, Stop2);

        (* 15-10-92*)
	if Symbol in ExpressionSymbols then
		 ParallelStatementDoubleDot( Stop2 )
	else if Symbol in [ Do1 , Threshold1] then
		 ParallelStatementDoublebar( Stop2 )
	else SyntaxError(Stop2);
 end;

 { IfStatement = "if" Expression "then" Statement [ "else" Statement ]. }
 Procedure ifStatement(Stop: Symbols);
 Var
   ExprType: Ptr;
   Label1, Label2 : Longint;
 begin
   Expect(if1, ExpressionSymbols + [then1, else1] +
               StatementSymbols + Stop);
   Expression(ExprType, [then1, else1] +
                        StatementSymbols + Stop);
   CheckTypes(ExprType, TypeBoolean);
   Expect(then1, StatementSymbols + [else1] + Stop);

   if LevelPar <> 0 then      {O SE TRATA DE UN IF EN PARALELO}
      begin
         Emit1(Pushpattern2);
         Push( 0, MaxRecords);
         Emit1(cOpytOps2);
         Pop(levelPar, typelength(ExprType));
         NewLabel( Label1 );
         Emit2( goifzero2, Label1);
         Statement([else1] + Stop);
         if Symbol = else1 then
            begin
               Emit2( DefAddr2, Label1);
               Emit1(complement2);
               NewLabel(Label2);
               Emit2( goifzero2, Label2);
               Expect(else1, StatementSymbols + Stop);
               Statement(Stop);
               Emit2( DefAddr2, Label2)
            end
         else Emit2( DefAddr2, Label1);
         Emit1(Poppattern2);
         Pop( 0, MaxRecords);
      end
   else      {O SE TRATA UN IF SECUENCIAL }
      begin
         NewLabel(Label1);
         Emit2(do2, Label1);
         Pop( LevelPar , 1);
         Statement([else1] + Stop);
         if Symbol = else1 then
            begin
              Expect(else1, StatementSymbols + Stop);
              NewLabel(Label2);
              Emit2(goto2, Label2);
              Emit2(DefAddr2, Label1);
              Statement(Stop);
              Emit2(DefAddr2, Label2)
            end
         else Emit2(DefAddr2, Label1)
      end
 end;

 { WhileStatement = "while" Expression "do" Statement . }
 Procedure whileStatement(Stop: Symbols);
 Var
   Label1, Label2 : Longint;
   ExprType: Ptr;
 begin
   if LevelPar <> 0 then    {O Se est ante un while  Paralelo }
      begin
         Expect(while1, ExpressionSymbols +
                         [do1] + StatementSymbols + Stop);
         Emit1(Pushpattern2);
         Push( 0, MaxRecords);
         NewLabel(Label1);
         Emit2(DefAddr2, Label1);
         Expression(ExprType, [do1] +
                              StatementSymbols + Stop);
         CheckTypes(ExprType, TypeBoolean);
         Emit1(cOpytOps2);
         Pop(LevelPar, typelength(ExprType));
         Expect(do1, StatementSymbols + Stop);
         NewLabel(Label2);
         Emit2(goifzero2, Label2);
         Statement(Stop);

         Emit2(goto2, Label1);
         Emit2(DefAddr2, Label2);
         Emit1(Poppattern2);
      end
   else   {O el while es secuencial, se debera entrar aqu slo si }
      begin                   { LevelPar est a cero .}
         NewLabel(Label1);
         Emit2(DefAddr2, Label1);
         Expect(while1, ExpressionSymbols +
                         [do1] + StatementSymbols + Stop);
         Expression(ExprType, [do1] +
                              StatementSymbols + Stop);
         CheckTypes(ExprType, TypeBoolean);
         Expect(do1, StatementSymbols + Stop);
         NewLabel(Label2);
         Emit2(do2, Label2);
         Pop( LevelPar , 1);
         Statement(Stop);
         Emit2(goto2, Label1);
         Emit2(DefAddr2, Label2)
      end
 end;

 { RepeatStatement = "Repeat" Statement  ";" Statement !
                     "Until" Expression.  }
 Procedure repeatStatement(Stop:Symbols);
 Var
   Label1,Label2: Longint;
   ExprType: Ptr;
 begin
   Expect( repeat1, StatementSymbols + [semicolon1, until1, end1] +
						  ExpressionSymbols + Stop );
	if LevelPar <> 0 then
		begin
			Emit1(PushPattern2);
			Push( 0, MaxRecords );
			NewLabel(Label1);
			Emit2(DefAddr2, Label1);
			Statement( [semicolon1, until1] + ExpressionSymbols + Stop);
			while Symbol = semicolon1 do
			  begin
				 Expect( semicolon1, StatementSymbols + [ semicolon1, until1, end1] +
							ExpressionSymbols + Stop);
				 Statement( [ semicolon1, until1 ] + ExpressionSymbols + Stop);
			  end;
			Expect( until1, ExpressionSymbols + Stop);
			Expression( ExprType, Stop);
			CheckTypes( ExprType, TypeBoolean);
			Emit1( CopyNotops2);
			Emit2( GoifnoZero2, Label1);
			Emit1( PopPattern2 );
			Pop( 0, MaxRecords );
		end
	else
		begin
			NewLabel(Label1);
         Emit2(DefAddr2, Label1);
         Statement( [semicolon1, until1] +
                    ExpressionSymbols + Stop);
         while Symbol = semicolon1 do
           begin
             Expect( semicolon1, StatementSymbols +
                     [ semicolon1, until1, end1] +
                     ExpressionSymbols + Stop);
             Statement( [ semicolon1, until1 ] +
                        ExpressionSymbols + Stop);
           end;
         Expect( until1, ExpressionSymbols + Stop);
         Expression( ExprType, Stop);
         CheckTypes(ExprType, TypeBoolean);
         NewLabel(Label2);
         Emit2(Notdo2, Label2);
         Pop( LevelPar , 1);
         Emit2(goto2, Label1);
         Emit2(DefAddr2, Label2);
      end
 end;

 { ForStatement = "For" Expression To Expression [STEP Constant] "Do"
                   Statement .
   Implicit counter is always i
 }
 Procedure forStatement( Stop:Symbols);
 Var
  Stop1 : Symbols;
  Label1, Label2, value : Longint;
  VarCounterx, ExprType1, ExprType2, TypeConst : Ptr;
  down : boolean;
 begin
   Find( counter0, VarCounterx);    (* counter0 is the name of counter *)

   Stop1 := ExpressionSymbols + [to1, step1, do1] + StatementSymbols + Stop;

   if LevelPar <> 0 then emit1( PushPattern2 );

   Expect( for1, [Name1] + Stop1);

   Expression( ExprType1, Stop1 );
   CheckTypes( VarCounterx^.varType, ExprType1);

   Expect( to1, Stop1);

   Expression( ExprType2, [step1, do1] + ExpressionSymbols + StatementSymbols + Stop);
   CheckTypes( VarCounterx^.varType, ExprType2);

   if (Symbol = Step1) then
   begin
     Expect( Step1, [do1] + ExpressionSymbols + StatementSymbols + Stop );

     if (Symbol = Minus1) then
     begin
       Expect( Minus1, [do1] + ExpressionSymbols + StatementSymbols + Stop );
       down := true;
     end;

     Constant( value, TypeConst, [do1] + StatementSymbols + Stop);
     CheckTypes( TypeConst, TypeInteger);
     if down then
       value := -value;
   end
   else value := 1;

   Expect( do1, StatementSymbols + Stop);

   NewLabel( Label1);
   NewLabel( Label2);

   LevelFor := LevelFor + 1;

   if LevelFor = 1 then Emit2( initFor2, Label2)
   else emit2( initNestedFor2, Label2);

   Emit2( DefAddr2, Label1);

   Statement( Stop );

   if LevelFor = 1 then Emit3( loop2, Label1, value)
   else emit3( Nestedloop2, Label1, value);

   Emit2( DefAddr2, Label2);

   if LevelPar <> 0 then emit1( PopPattern2 );

   LevelFor := LevelFor - 1;
 end; (* forStatement *)

 { Statement = RelaxStatement | UnRelaxStatement }
 { RelaxStatement = RELAX UnRelaxStatement }
 { UnRelaxStatement = AssingStatement | ProcedureStatement | IfStatement
                      WhileStatement | RepeatStatement | ForStatement |
                      SemiBlockStatement | CompoundStatement | Empty . }

 Procedure UnRelaxStatement(Stop: Symbols); forward;
 Procedure compoundStatement( Stop: Symbols); forward;

 Procedure semiBlockStatement( Stop : Symbols);
 Var
   VarLength : Longint;
 begin
   NewBlock;
   Push(LevelPar, 3);
   VariableDefinitionPart( VarLength, [begin1] + Stop);
   if LevelPar <> 0 then Block[BlockLevel].ElementalVar := VarLength
   else Block[BlockLevel].VarLength := VarLength;
   Emit2( NewBlock2, VarLength);
   CompoundStatement(Stop);
   Emit1(EndBlock2);
   Pop(LevelPar, 3);
   endBlock
 end;


 { Statement = RelaxStatement | UnRelaxStatement }
 { RelaxStatement = RELAX UnRelaxStatement }
 Procedure Statement(Stop : Symbols);
 begin
   if Symbol = Relax1 then
     begin
       Expect( Relax1, StatementSymbols + Stop );
       emit1( Relax2);
       UnRelaxStatement( Stop );
       emit1( EndRelax2);
     end
   else UnRelaxStatement(Stop);
 end; (* Statement *)


 { UnRelaxStatement = AssingStatement | ProcedureStatement | IfStatement
                      WhileStatement | RepeatStatement | ForStatement |
                      SemiBlockStatement | CompoundStatement | Empty . }
 Procedure UnRelaxStatement(Stop: Symbols);
 Var
   Objt: Ptr;
 begin
   if Symbol = Name1 then
      begin
        Find(Argument, Objt);
        if Objt^.Kind in Variables then
           asSignmentStatement(Stop)
        else if Objt^.Kind in Procedures then
           ProcedureStatement(Stop)
        else
           begin
             KindError(Objt);
             Expect(Name1, Stop)
           end
      end
   else if Symbol = Parallel1 then ParallelStatement(Stop)
   else if Symbol = if1 then ifStatement(Stop)
   else if Symbol = while1 then whileStatement(Stop)
   else if Symbol = repeat1 then repeatStatement(Stop)
   else if Symbol = for1 then forStatement(Stop)
   else if Symbol = Var1 then semiBlockStatement(Stop)
   else if Symbol = begin1 then compoundStatement(Stop)
   else { empty }
      SyntaxCheck(Stop)
 end;

 { CompoundStatement = "begin" Statement [ ";" Statement ] "end" . }
 Procedure compoundStatement(Stop:Symbols);
 begin
   Expect(begin1, StatementSymbols + [semicolon1, end1] + Stop);
   Statement([semicolon1, end1] + Stop);
   while Symbol = semicolon1 do
     begin
       Expect(semicolon1, StatementSymbols + [semicolon1, end1] + Stop);
       Statement([semicolon1, end1] + Stop)
     end;
   Expect(end1, Stop)
 end; (* CompoundStatement *)

 { BlockBody = [ ConstantDefinitionPart ] [ TypeDefinitionPart ]
               [ VariableDefinitionPart ] [ ProcedureDefinition ]
               CompoundStatement . }
 Procedure Blockbody( beginLabel, VarLabel : Longint;
                      Stop: Symbols );
 Var
   VarLength: Longint;
 begin
   SyntaxCheck(BlockSymbols + Stop);
   if Symbol = Const1 then
     ConstantDefinitionPart([Type1,Var1,Procedure1,shared1,Begin1] + Stop);
   if Symbol = Type1 then
      TypeDefinitionPart([Var1, Procedure1, shared1, begin1] + Stop);
   if Symbol = Var1 then
      VariableDefinitionPart( VarLength,[Procedure1, shared1, begin1] + Stop)
   else VarLength := 0;
   if LevelPar <> 0 then Block[BlockLevel].ElementalVar := VarLength
   else Block[BlockLevel].VarLength := VarLength;
   while Symbol in ProcedureSymbols do
       ProcedureDefinition( ProcedureSymbols + [begin1] + Stop );
   Emit2(DefAddr2,beginLabel);
   CompoundStatement(Stop);
   Emit3(DefArg2, VarLabel, VarLength);
 end;

 { Program = "program" ProgramName ";" BlockBody "." }
 Procedure programx(Stop: Symbols);
 Var
   VarLabel, TempControlLabel, TempElementalLabel, beginLabel: Longint;
 begin
   Expect(program1, [Name1, semicolon1, period1] + BlockSymbols + Stop);
   Expect(Name1, [semicolon1, period1] + BlockSymbols + Stop);
   NewLabel(VarLabel);
   NewLabel(TempControlLabel);
   NewLabel(TempElementalLabel);
   NewLabel(beginLabel);
   Emit5(program2,
         VarLabel, TempControlLabel, TempElementalLabel, BeginLabel);
   Expect( SemiColon1, [period1] + BlockSymbols + Stop);
   NewBlock;
   Blockbody(BeginLabel, VarLabel, [period1] + Stop);
   EndBlock;
   Expect(period1, Stop);
   Emit3(DefArg2, TempControlLabel, ControlBlockMax +
                                    ElementalBlockMax +
                                    ControlVarBlockMax + 3);
   Emit3(DefArg2, TempElementalLabel, ElementalBlockMax +
                                      ElementalVarBlockMax);
   Emit1(EndProg2);
 end;

 Procedure Analizador_Sintactico;
 begin
   Initialize;
   NextSymbol;
   StandardBlock;
   programx([endtext1])
 end;

end.


